<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package fresh_bakers_shop
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function fresh_bakers_shop_body_classes( $classes ) {
  global $fresh_bakers_shop_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( fresh_bakers_shop_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'fresh_bakers_shop_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function fresh_bakers_shop_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'fresh_bakers_shop_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function fresh_bakers_shop_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'fresh_bakers_shop_excerpt_more' );


if( ! function_exists( 'fresh_bakers_shop_footer_credit' ) ):
/**
 * Footer Credits
*/
function fresh_bakers_shop_footer_credit() {
    $fresh_bakers_shop_copyright_text = get_theme_mod('fresh_bakers_shop_footer_copyright_text');

    $fresh_bakers_shop_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($fresh_bakers_shop_copyright_text) {
        $fresh_bakers_shop_text .= wp_kses_post($fresh_bakers_shop_copyright_text); 
    } else {
        $fresh_bakers_shop_text .= esc_html__('&copy; ', 'fresh-bakers-shop') . date_i18n(esc_html__('Y', 'fresh-bakers-shop')); 
        $fresh_bakers_shop_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'fresh-bakers-shop');
    }
        $fresh_bakers_shop_text .= '</span>';
       $fresh_bakers_shop_text .= '<span class="by"> '.FRESH_BAKERS_SHOP_THEME_NAME . ' '. esc_html__( 'By ', 'fresh-bakers-shop' ) . '<a href="' . esc_url( 'https://themeignite.com/' ) .'" rel="nofollow" target="_blank">' . esc_html__( 'Themeignite', 'fresh-bakers-shop' ) . '</a>.';
        $fresh_bakers_shop_text .= sprintf( esc_html__( ' Powered By %s', 'fresh-bakers-shop' ), '<a href="'. esc_url( __( 'https://wordpress.org/', 'fresh-bakers-shop' ) ) .'" target="_blank">WordPress</a>.' );
        if ( function_exists( 'the_privacy_policy_link' ) ) {
            $fresh_bakers_shop_text .= get_the_privacy_policy_link();
        }
        $fresh_bakers_shop_text .= '</span></div></div>';
    echo apply_filters('fresh_bakers_shop_footer_text', $fresh_bakers_shop_text);
}
add_action('fresh_bakers_shop_footer', 'fresh_bakers_shop_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'fresh_bakers_shop_woocommerce_activated' ) ) {
  function fresh_bakers_shop_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'fresh_bakers_shop_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function fresh_bakers_shop_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $fresh_bakers_shop_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $fresh_bakers_shop_aria_req = ( $req ? " aria-required='true'" : '' );
    $fresh_bakers_shop_required = ( $req ? " required" : '' );
    $fresh_bakers_shop_author   = ( $req ? __( 'Name*', 'fresh-bakers-shop' ) : __( 'Name', 'fresh-bakers-shop' ) );
    $fresh_bakers_shop_email    = ( $req ? __( 'Email*', 'fresh-bakers-shop' ) : __( 'Email', 'fresh-bakers-shop' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'fresh-bakers-shop' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $fresh_bakers_shop_author ) . '" type="text" value="' . esc_attr( $fresh_bakers_shop_commenter['comment_author'] ) . '" size="30"' . $fresh_bakers_shop_aria_req . $fresh_bakers_shop_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'fresh-bakers-shop' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $fresh_bakers_shop_email ) . '" type="text" value="' . esc_attr(  $fresh_bakers_shop_commenter['comment_author_email'] ) . '" size="30"' . $fresh_bakers_shop_aria_req . $fresh_bakers_shop_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'fresh-bakers-shop' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'fresh-bakers-shop' ) . '" type="text" value="' . esc_attr( $fresh_bakers_shop_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'fresh_bakers_shop_change_comment_form_default_fields' );

if( ! function_exists( 'fresh_bakers_shop_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function fresh_bakers_shop_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'fresh-bakers-shop' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'fresh-bakers-shop' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'fresh_bakers_shop_change_comment_form_defaults' );

if( ! function_exists( 'fresh_bakers_shop_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function fresh_bakers_shop_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'fresh_bakers_shop_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function fresh_bakers_shop_get_fallback_svg( $fresh_bakers_shop_post_thumbnail ) {
    if( ! $fresh_bakers_shop_post_thumbnail ){
        return;
    }
    
    $fresh_bakers_shop_image_size = fresh_bakers_shop_get_image_sizes( $fresh_bakers_shop_post_thumbnail );
     
    if( $fresh_bakers_shop_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $fresh_bakers_shop_image_size['width'] ); ?> <?php echo esc_attr( $fresh_bakers_shop_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $fresh_bakers_shop_image_size['width'] ); ?>" height="<?php echo esc_attr( $fresh_bakers_shop_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function fresh_bakers_shop_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-inter',
        fresh_bakers_shop_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Inter:ital,opsz,wght@0,14..32,100..900;1,14..32,100..900&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-marcellus',
        fresh_bakers_shop_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Marcellus&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'fresh_bakers_shop_enqueue_google_fonts' );


if( ! function_exists( 'fresh_bakers_shop_site_branding' ) ) :
/**
 * Site Branding
*/
function fresh_bakers_shop_site_branding(){
    $fresh_bakers_shop_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $fresh_bakers_shop_tagline = get_theme_mod( 'header_tagline', false );
    $fresh_bakers_shop_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($fresh_bakers_shop_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('fresh_bakers_shop_site_title_size', '20')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($fresh_bakers_shop_tagline) :
            $fresh_bakers_shop_description = get_bloginfo('description', 'display');
            if ($fresh_bakers_shop_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $fresh_bakers_shop_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'fresh_bakers_shop_navigation' ) ) :
    /**
     * Site Navigation
    */
    function fresh_bakers_shop_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'fresh_bakers_shop_header' ) ) :
    /**
     * Header Start
    */
    function fresh_bakers_shop_header(){
        $fresh_bakers_shop_header_image = get_header_image();
        $fresh_bakers_shop_sticky_header = get_theme_mod('fresh_bakers_shop_sticky_header');
        $fresh_bakers_shop_header_setting     = get_theme_mod( 'fresh_bakers_shop_header_setting', false );
        ?>
        <div id="page-site-header" class="main-header">
            <header id="masthead" class="site-header header-inner" role="banner">
                <div class="theme-menu head_bg" <?php echo $fresh_bakers_shop_header_image != '' ? 'style="background-image: url(' . esc_url( $fresh_bakers_shop_header_image ) . '); background-repeat: no-repeat; background-size: cover"': ""; ?> data-sticky="<?php echo esc_attr( $fresh_bakers_shop_sticky_header ); ?>">
                    <div class="container">
                        <div class="row menu-bg py-2">
                            <div class="col-xl-2 col-lg-2 col-md-5 col-md-left align-self-center">
                                <?php fresh_bakers_shop_site_branding(); ?>
                            </div>
                            <div class="col-xl-8 col-lg-8 col-md-1 align-self-center">
                                <?php fresh_bakers_shop_navigation(); ?> 
                            </div>
                            <div class="col-xl-2 col-lg-2 col-md-6 col-md-right align-self-center">
                                <div class="woocomerce-content">

                                    <span>
                                        <?php 
                                        if (defined('YITH_WCWL') && class_exists('YITH_WCWL_Wishlists')) {?>
                                        <a class="wishlist-btn" href="<?php echo esc_url(YITH_WCWL()->get_wishlist_url()); ?>">
                                            <i class="fas fa-heart"></i>
                                            <span class="label-text"><?php echo esc_html__( 'Wishlist', 'fresh-bakers-shop' ); ?></span>
                                        </a>
                                        <?php }?>
                                    </span>

                                    <?php if (class_exists('woocommerce')) { ?>
                                        <span class="cart-btn">
                                            <a class="cart-customlocation" href="<?php if (function_exists('wc_get_cart_url')) { echo esc_url(wc_get_cart_url()); } ?>" title="<?php esc_attr_e('View Shopping Cart', 'fresh-bakers-shop'); ?>">
                                                <i class="fas fa-shopping-cart"></i>
                                                <span class="label-text"><?php echo esc_html__( 'Cart', 'fresh-bakers-shop' ); ?></span>
                                            </a>
                                        </span>
                                    <?php } ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>                 
            </header>
        </div>
        <?php
    }
endif;
add_action( 'fresh_bakers_shop_header', 'fresh_bakers_shop_header', 20 );
